Save This Page
Home » spring-framework-2.5.5-with-dependencies » org.springframework » web » portlet » mvc » [javadoc | source]
org.springframework.web.portlet.mvc
abstract public class: AbstractWizardFormController [javadoc | source]
java.lang.Object
   org.springframework.context.support.ApplicationObjectSupport
      org.springframework.web.portlet.context.PortletApplicationObjectSupport
         org.springframework.web.portlet.handler.PortletContentGenerator
            org.springframework.web.portlet.mvc.AbstractController
               org.springframework.web.portlet.mvc.BaseCommandController
                  org.springframework.web.portlet.mvc.AbstractFormController
                     org.springframework.web.portlet.mvc.AbstractWizardFormController

All Implemented Interfaces:
    Controller, PortletContextAware, ApplicationContextAware

Form controller for typical wizard-style workflows.

In contrast to classic forms, wizards have more than one form view page. Therefore, there are various actions instead of one single submit action:

Finish and cancel actions can be triggered by request parameters, named PARAM_FINISH ("_finish") and PARAM_CANCEL ("_cancel"), ignoring parameter values to allow for HTML buttons. The target page for page changes can be specified by PARAM_TARGET, appending the page number to the parameter name (e.g. "_target1"). The action parameters are recognized when triggered by image buttons too (via "_finish.x", "_abort.x", or "_target1.x").

The current page number will be stored in the session. It can also be specified as request parameter PARAM_PAGE ("_page") in order to properly handle usage of the back button in a browser: In this case, a submission will always contain the correct page number, even if the user submitted from an old view.

The page can only be changed if it validates correctly, except if a "dirty back" or "dirty forward" is allowed. At finish, all pages get validated again to guarantee a consistent state.

Note that a validator's default validate method is not executed when using this class! Rather, the validatePage implementation should call special validateXXX methods that the validator needs to provide, validating certain pieces of the object. These can be combined to validate the elements of individual pages.

Note: Page numbering starts with 0, to be able to pass an array consisting of the corresponding view names to the "pages" bean property.

Parameters indicated with setPassRenderParameters will be present for each page. If there are render parameters you need in renderFinish or renderCancel, then you need to pass those forward from the processFinish or processCancel methods, respectively.

Field Summary
public static final  String PARAM_FINISH    Parameter triggering the finish action. Can be called from any wizard page! 
public static final  String PARAM_CANCEL    Parameter triggering the cancel action. Can be called from any wizard page! 
public static final  String PARAM_TARGET    Parameter specifying the target page, appending the page number to the name. 
public static final  String PARAM_PAGE    Parameter specifying the current page as value. Not necessary on form pages, but allows to properly handle usage of the back button. 
Fields inherited from org.springframework.web.portlet.mvc.BaseCommandController:
DEFAULT_COMMAND_NAME
Fields inherited from org.springframework.context.support.ApplicationObjectSupport:
logger
Constructor:
 public AbstractWizardFormController() 
Method from org.springframework.web.portlet.mvc.AbstractWizardFormController Summary:
getCurrentPage,   getInitialPage,   getInitialPage,   getPageAttribute,   getPageCount,   getPageCount,   getPageSessionAttributeName,   getPageSessionAttributeName,   getPages,   getTargetPage,   getTargetPage,   getViewName,   handleInvalidSubmit,   isAllowDirtyBack,   isAllowDirtyForward,   isCancelRequest,   isFinishRequest,   isFormSubmission,   onBindAndValidate,   onBindAndValidate,   postProcessPage,   processCancel,   processFinish,   processFormSubmission,   referenceData,   referenceData,   referenceData,   renderCancel,   renderFinish,   renderFormSubmission,   renderInvalidSubmit,   setAllowDirtyBack,   setAllowDirtyForward,   setCancelRenderParameter,   setFinishRenderParameter,   setPageAttribute,   setPageRenderParameter,   setPages,   setTargetRenderParameter,   showForm,   showPage,   validatePage,   validatePage
Methods from org.springframework.web.portlet.mvc.AbstractFormController:
formBackingObject,   getCommand,   getErrorsForNewForm,   getFormSessionAttributeName,   getFormSessionAttributeName,   getFormSubmitParameterName,   getInvalidSubmitParameterName,   getRenderParameters,   handleActionRequestInternal,   handleInvalidSubmit,   handleRenderRequestInternal,   isBindOnNewForm,   isFormSubmission,   isInvalidSubmission,   isRedirectAction,   isSessionForm,   onBindOnNewForm,   onBindOnNewForm,   passRenderParameters,   processFormSubmission,   referenceData,   renderFormSubmission,   renderInvalidSubmit,   setBindOnNewForm,   setFormSubmit,   setInvalidSubmit,   setRedirectAction,   setRenderParameters,   setSessionForm,   showForm,   showForm,   showForm,   showNewForm
Methods from org.springframework.web.portlet.mvc.BaseCommandController:
bindAndValidate,   checkCommand,   createBinder,   createCommand,   getBindingErrorProcessor,   getCommand,   getCommandClass,   getCommandName,   getMessageCodesResolver,   getPropertyEditorRegistrars,   getRenderCommand,   getRenderCommandSessionAttributeName,   getRenderErrors,   getRenderErrorsSessionAttributeName,   getValidator,   getValidators,   getWebBindingInitializer,   initApplicationContext,   initBinder,   isValidateOnBinding,   onBind,   onBind,   onBindAndValidate,   prepareBinder,   setBindingErrorProcessor,   setCommandClass,   setCommandName,   setMessageCodesResolver,   setPropertyEditorRegistrar,   setPropertyEditorRegistrars,   setRenderCommandAndErrors,   setValidateOnBinding,   setValidator,   setValidators,   setWebBindingInitializer,   suppressBinding,   suppressValidation,   useDirectFieldAccess
Methods from org.springframework.web.portlet.mvc.AbstractController:
handleActionRequest,   handleActionRequestInternal,   handleRenderRequest,   handleRenderRequestInternal,   isRenderWhenMinimized,   isSynchronizeOnSession,   setRenderWhenMinimized,   setSynchronizeOnSession
Methods from org.springframework.web.portlet.handler.PortletContentGenerator:
applyCacheSeconds,   cacheForSeconds,   check,   checkAndPrepare,   checkAndPrepare,   getCacheSeconds,   isRequireSession,   preventCaching,   setCacheSeconds,   setRequireSession
Methods from org.springframework.web.portlet.context.PortletApplicationObjectSupport:
getPortletContext,   getTempDir,   isContextRequired,   setPortletContext
Methods from org.springframework.context.support.ApplicationObjectSupport:
getApplicationContext,   getMessageSourceAccessor,   initApplicationContext,   initApplicationContext,   isContextRequired,   requiredContextClass,   setApplicationContext
Methods from java.lang.Object:
equals,   getClass,   hashCode,   notify,   notifyAll,   toString,   wait,   wait,   wait
Method from org.springframework.web.portlet.mvc.AbstractWizardFormController Detail:
 protected int getCurrentPage(PortletRequest request) 
    Return the current page number. Used by #processFormSubmission .

    The default implementation checks the page session attribute. Subclasses can override this for customized page determination.

 protected int getInitialPage(PortletRequest request) 
    Return the initial page of the wizard, i.e. the page shown at wizard startup. Default implementation returns 0 for first page.
 protected int getInitialPage(PortletRequest request,
    Object command) 
    Return the initial page of the wizard, i.e. the page shown at wizard startup. Default implementation delegates to getInitialPage(PortletRequest).
 public final String getPageAttribute() 
    Return the name of the page attribute in the model.
 protected final int getPageCount() 
    Return the number of wizard pages. Useful to check whether the last page has been reached.

    Note that a concrete wizard form controller might override getPageCount(PortletRequest, Object) to determine the page count dynamically.

 protected int getPageCount(PortletRequest request,
    Object command) 
    Return the page count for this wizard form controller. Default implementation delegates to getPageCount().

    Can be overridden to dynamically adapt the page count.

 protected String getPageSessionAttributeName() 
    Return the name of the PortletSession attribute that holds the page object for this wizard form controller.

    Default is an internal name, of no relevance to applications, as the form session attribute is not usually accessed directly. Can be overridden to use an application-specific attribute name, which allows other code to access the session attribute directly.

 protected String getPageSessionAttributeName(PortletRequest request) 
    Return the name of the PortletSession attribute that holds the page object for this wizard form controller.

    Default implementation delegates to the getPageSessionAttributeName version without arguments.

 public final String[] getPages() 
    Return the wizard pages, i.e. the view names for the pages. The array index corresponds to the page number.

    Note that a concrete wizard form controller might override getViewName(PortletRequest, Object, int) to determine the view name for each page dynamically.

 protected int getTargetPage(PortletRequest request,
    int currentPage) 
    Return the target page specified in the request.

    Default implementation examines "_target" parameter (e.g. "_target1"). Subclasses can override this for customized target page determination.

 protected int getTargetPage(PortletRequest request,
    Object command,
    Errors errors,
    int currentPage) 
    Return the target page specified in the request.

    Default implementation delegates to getTargetPage(PortletRequest, int). Subclasses can override this for customized target page determination.

 protected String getViewName(PortletRequest request,
    Object command,
    int page) 
    Return the name of the view for the specified page of this wizard form controller. Default implementation takes the view name from the getPages() array.

    Can be overridden to dynamically switch the page view or to return view names for dynamically defined pages.

 protected  void handleInvalidSubmit(ActionRequest request,
    ActionResponse response) throws Exception 
    Handle an invalid submit request, e.g. when in session form mode but no form object was found in the session (like in case of an invalid resubmit by the browser).

    Default implementation for wizard form controllers simply shows the initial page of a new wizard form, so here in the action phase this method does nothing. If you want to take some action on an invalid submit, you need to override this method.

 public final boolean isAllowDirtyBack() 
    Return whether "dirty back" is allowed.
 public final boolean isAllowDirtyForward() 
    Return whether "dirty forward" is allowed.
 protected boolean isCancelRequest(PortletRequest request) 
    Determine whether the incoming request is a request to cancel the processing of the current form.

    By default, this method returns true if a parameter matching the "_cancel" key is present in the request, otherwise it returns false. Subclasses may override this method to provide custom logic to detect a cancel request.

    The parameter is recognized both when sent as a plain parameter ("_cancel") or when triggered by an image button ("_cancel.x").

 protected boolean isFinishRequest(PortletRequest request) 
    Determine whether the incoming request is a request to finish the processing of the current form.

    By default, this method returns true if a parameter matching the "_finish" key is present in the request, otherwise it returns false. Subclasses may override this method to provide custom logic to detect a finish request.

    The parameter is recognized both when sent as a plain parameter ("_finish") or when triggered by an image button ("_finish.x").

 protected boolean isFormSubmission(PortletRequest request) 
    Consider an explicit finish or cancel request as a form submission too.
 protected final  void onBindAndValidate(PortletRequest request,
    Object command,
    BindException errors) throws Exception 
    Calls page-specific onBindAndValidate method.
 protected  void onBindAndValidate(PortletRequest request,
    Object command,
    BindException errors,
    int page) throws Exception 
    Callback for custom post-processing in terms of binding and validation. Called on each submit, after standard binding but before page-specific validation of this wizard form controller.

    Note: AbstractWizardFormController does not perform standard validation on binding but rather applies page-specific validation on processing the form submission.

 protected  void postProcessPage(ActionRequest request,
    Object command,
    Errors errors,
    int page) throws Exception 
    Post-process the given page after binding and validation, potentially updating its command object. The passed-in request might contain special parameters sent by the page.

    Only invoked when displaying another page or the same page again, not when finishing or cancelling.

 protected  void processCancel(ActionRequest request,
    ActionResponse response,
    Object command,
    BindException errors) throws Exception 
    Template method for the action phase of the cancel action of this wizard.

    Default implementation throws a PortletException, saying that a cancel action request is not supported by this controller. Thus, you do not need to implement this template method if you do not support a cancel operation.

 protected  void processFinish(ActionRequest request,
    ActionResponse response,
    Object command,
    BindException errors) throws Exception 
    Template method for the action phase of the finish action of this wizard.

    Default implementation throws a PortletException, saying that a finish action request is not supported by this controller. You will almost certainly need to override this method.

 protected final  void processFormSubmission(ActionRequest request,
    ActionResponse response,
    Object command,
    BindException errors) throws Exception 
    Apply wizard workflow: finish, cancel, page change.
 protected Map referenceData(PortletRequest request,
    int page) throws Exception 
    Create a reference data map for the given request, consisting of bean name/bean instance pairs as expected by ModelAndView.

    Default implementation returns null. Subclasses can override this to set reference data used in the view.

 protected final Map referenceData(PortletRequest request,
    Object command,
    Errors errors) throws Exception 
    Calls page-specific referenceData method.
 protected Map referenceData(PortletRequest request,
    Object command,
    Errors errors,
    int page) throws Exception 
    Create a reference data map for the given request, consisting of bean name/bean instance pairs as expected by ModelAndView.

    Default implementation delegates to referenceData(HttpServletRequest, int). Subclasses can override this to set reference data used in the view.

 protected ModelAndView renderCancel(RenderRequest request,
    RenderResponse response,
    Object command,
    BindException errors) throws Exception 
    Template method for the render phase of the cancel action of this wizard.

    Default implementation throws a PortletException, saying that a cancel render request is not supported by this controller. Thus, you do not need to implement this template method if you do not support a cancel operation.

    Call errors.getModel() to populate the ModelAndView model with the command and the Errors instance, under the specified command name, as expected by the "spring:bind" tag.

 protected ModelAndView renderFinish(RenderRequest request,
    RenderResponse response,
    Object command,
    BindException errors) throws Exception 
    Template method for the render phase of the finish action of this wizard.

    Default implementation throws a PortletException, saying that a finish render request is not supported by this controller. Thus, you do not need to implement this template method if you do not need to render after a finish.

    Call errors.getModel() to populate the ModelAndView model with the command and the Errors instance, under the specified command name, as expected by the "spring:bind" tag.

 protected final ModelAndView renderFormSubmission(RenderRequest request,
    RenderResponse response,
    Object command,
    BindException errors) throws Exception 
    Apply wizard workflow: finish, cancel, page change.
 protected ModelAndView renderInvalidSubmit(RenderRequest request,
    RenderResponse response) throws Exception 
    Handle an invalid submit request, e.g. when in session form mode but no form object was found in the session (like in case of an invalid resubmit by the browser).

    Default implementation for wizard form controllers simply shows the initial page of a new wizard form. If you want to show some "invalid submit" message, you need to override this method.

 public final  void setAllowDirtyBack(boolean allowDirtyBack) 
    Set if "dirty back" is allowed, i.e. if moving to a former wizard page is allowed in case of validation errors for the current page.
 public final  void setAllowDirtyForward(boolean allowDirtyForward) 
    Set if "dirty forward" is allowed, i.e. if moving to a later wizard page is allowed in case of validation errors for the current page.
 protected  void setCancelRenderParameter(ActionRequest request,
    ActionResponse response) 
    Pass the the parameter that indicates a cancel request forward to the render phase. If the isCancelRequest method was overridden, this may need to be overriden as well.
 protected  void setFinishRenderParameter(ActionRequest request,
    ActionResponse response) 
    Pass the the parameter that indicates a finish request forward to the render phase. If the isFinishRequest method was overridden, this may need to be overriden as well.
 public final  void setPageAttribute(String pageAttribute) 
    Set the name of the page attribute in the model, containing an Integer with the current page number.

    This will be necessary for single views rendering multiple view pages. It also allows for specifying the optional "_page" parameter.

 protected  void setPageRenderParameter(ActionResponse response,
    int page) 
 public final  void setPages(String[] pages) 
    Set the wizard pages, i.e. the view names for the pages. The array index is interpreted as page number.
 protected  void setTargetRenderParameter(ActionRequest request,
    ActionResponse response) 
    Pass the the parameter that indicates the target page of the request forward to the render phase. If the getTargetPage method was overridden, this may need to be overriden as well.
 protected ModelAndView showForm(RenderRequest request,
    RenderResponse response,
    BindException errors) throws Exception 
    Show the first page as form view.

    This can be overridden in subclasses, e.g. to prepare wizard-specific error views in case of an Exception.

 protected final ModelAndView showPage(RenderRequest request,
    BindException errors,
    int page) throws Exception 
    Prepare the form model and view, including reference and error data, for the given page. Can be used in processFinish implementations, to show the corresponding page in case of validation errors.
 protected  void validatePage(Object command,
    Errors errors,
    int page) 
    Template method for custom validation logic for individual pages. Default implementation is empty.

    Implementations will typically call fine-granular validateXXX methods of this instance's validator, combining them to validation of the corresponding pages. The validator's default validate method will not be called by a wizard form controller!

 protected  void validatePage(Object command,
    Errors errors,
    int page,
    boolean finish) 
    Template method for custom validation logic for individual pages. Default implementation calls validatePage(command, errors, page).

    Implementations will typically call fine-granular validateXXX methods of this instance's Validator, combining them to validation of the corresponding pages. The Validator's default validate method will not be called by a wizard form controller!